/********************************** (C) COPYRIGHT  *******************************
 * File Name          : iap.h
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2020/12/16
 * Description        : IAP
 * *Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/
#ifndef __IAP_H
#define __IAP_H

#include "ch32v20x.h"
#include "stdio.h"

/* FLASH䶨  */
#define ADDR_IAP       0x08000000
#define ADDR_APP       0x08002000
#define ADDR_APP_BUF   0x08008000

/*ǰ4ֽǲͷ@ W C H
        5ֽжARM/RVδ
        6ֽжAPP/IAP0x5A-APPڣ-APP
*/
#define ADDR_IAP_APP       0x0800FF00


#define CAN_ID       0x317
#define USBD_DATA_SIZE               64

#define BUILD_UINT16(loByte, hiByte) ((UINT16)(((loByte) & 0x00FF) | (((hiByte) & 0x00FF) << 8)))
#define BUILD_UINT32(Byte0, Byte1, Byte2, Byte3) \
          ((UINT32)((UINT32)((Byte0) & 0x00FF) \
          + ((((UINT32)Byte1) & 0x00FF) << 8) \
          + ((((UINT32)Byte2) & 0x00FF) << 16) \
          + ((((UINT32)Byte3) & 0x00FF) << 24)))

/* IAP CMD */
#define CMD_IAP_PROM             0x80
#define CMD_IAP_START            0x81
#define CMD_IAP_VERIFY           0x82
#define CMD_IAP_END              0x83
#define CMD_IAP_ALL_VERIFY       0x84
#define CMD_IAP_BufToApp         0x85

/* APP CMD */
#define CMD_APP_AppToIAP         0x50
#define CMD_APP_GetVersion       0x51

#define ERR_SCUESS               0x00
#define ERR_ERROR                0x01
#define ERR_End                  0x02

typedef struct __attribute__ ((aligned(4)))_ISP_CMD {
    u8 Cmd;
    u8 Len;
    u8 Rev[2];
    u8 data[60];
} isp_cmd;


extern u8 EP2_Rx_Buffer[USBD_DATA_SIZE];
void CAN_Mode_Init(u8 tsjw, u8 tbs2, u8 tbs1, u16 brp, u8 mode);
u8 RecData_Deal(void);
void Flash_Modify(void);
void LinkStatus( void );
void LED_Init(void);

#endif


