/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/*
 *@Note
 λFLASHUSBתCAN
 ע
 1. 谲װCH372
 2. MCU CH32V203C8T6
 3. CANID 0x317
 
 */

#include "debug.h"
#include "ch32v20x_usbotg_device.h"
#include "iap.h"
vu8 key_flag=0;

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    u8 CAN_Tx[4];

    Delay_Init();
    USART_Printf_Init(115200);
    PR("SystemClk7:%d\r\n", SystemCoreClock);
    PR("USB-CAN\r\n");


    /* Bps = 250Kbps */
    CAN_Mode_Init(CAN_SJW_1tq, CAN_BS2_5tq, CAN_BS1_6tq, 16, CAN_Mode_Normal);


    USBOTG_Init();
    while(1)
    {
        if(key_flag==0){
            if(KEY_Check()==0){
                CAN_Tx[0] = 0x50;
                CAN_Tx[1] = 0x02;
                CAN_Tx[2] = 0x00;
                CAN_Tx[3] = 0x00;
                CAN_Send_Msg(CAN_Tx, 4);
            }
       }
   }
}
